# test script for Solaris::Kstat

# Visit all the leaf nodes -
# will generate a die if there are any structure mismatches
sub visit_all($)
{
my ($ks) = @_;
foreach my $m (sort(keys(%$ks)))
   {
   foreach my $i (sort(keys(%{$ks->{$m}})))
      {
      foreach my $n (sort(keys(%{$ks->{$m}->{$i}})))
         {
         foreach my $k (sort(keys(%{$ks->{$m}->{$i}->{$n}})))
            {
            my $v = $ks->{$m}->{$i}->{$n}->{$k};
            }
         }
      }
   }
return(1);
}

BEGIN { $| = 1; print "1..6\n"; }
END {print "not ok 1\n" unless $loaded;}
use Solaris::Kstat;
$loaded = 1;
print "ok 1\n";

# Check we can create a Kstat object OK
my $ks;
if (! eval { $ks = Solaris::Kstat->new() })
   { print("not ok 2: $@\n"); }
else
   { print("ok 2\n"); }

# Check for structure mismatches
if (! eval { visit_all($ks) }) { print("not ok 3: $@\n"); }
else { print("ok 3\n"); }

# Check updates
if (! defined(eval { $ks->update() })) { print("not ok 4: $@\n"); }
else { print("ok 4\n"); }

# Check timestamps
my $then = $ks->{cpu_info}{0}{cpu_info0}{snaptime};
sleep(3);
if (! defined(eval { $ks->update() })) { print("not ok 5: $@\n"); }
else { print("ok 5\n"); }
my $interval = $ks->{cpu_info}{0}{cpu_info0}{snaptime} - $then;
if ($interval >= 2.9 && $interval <= 3.1)
   { print("ok 6\n"); }
else
   { print("not ok 7\n"); }

exit(0);
